//Segunda versión del switch de luz automático.
//Cambio de muestra del voltaje por tiempo de uso e integración de luz led

//Incluír las librerias necesarias.
#include <Servo.h>    //Librería para el control del micro servo
Servo servo;

#include <LiquidCrystal.h>    //Librería para el control de la LCD  
LiquidCrystal lcd(8, 9, 5, 4, 3, 2);


//Declarar variables y constantes
int MOTOR = 7;
int TRIGGER = 11;
int ECHO = 12;
int LUZ = 10;
int ESTADO = 0;
int MINS = 0;
int SEGS = 0;
int HRS = 0;
int CONTADOR = 0;
float SEGUNDOS;


//Función de inicialización SETUP
void setup(){
  Serial.begin(9600); //Inicializar el monitor serial
  lcd.begin(16, 2);   //Configuración para el LCD
  lcd.clear();

  servo.attach(MOTOR);//Configuración para el servo
  servo.write(0);

  //Activación de los pines necesarios
  pinMode(TRIGGER, OUTPUT);
  pinMode(ECHO, INPUT);
  pinMode(LUZ, OUTPUT);
}


//Funcion base LOOP

void loop(){
  delay(250); // Delay de 1/4 de segundo por repetición del programa
  
  float ACTIVE = DISTANCIA(); //Uso de la función distancia

  //Activar el servo con la cercanía
  //Si la distancia es menor a 10 cm entonces cambiara de apagado a encendido
  //Cambiar el "10" en caso de ser necesario, este es la distancia de acitvación
  //en cm
  
  if(ACTIVE <= 10){  
    //Cambio de estado con la cercanía
    if(ESTADO == 0){
     ESTADO = 1;
     servo.write(90);   //Movimiento del motor a encendido
    }
    else if(ESTADO == 1){
      ESTADO = 0;
      servo.write(-90); //Movimiento del motor a apagado
    }
   }

  
   //Si la distancia es mayor a 10cm, no pasará nada
   else if(ACTIVE > 10){
    if(ESTADO == 0){
      digitalWrite(LUZ, LOW);
    }
    else if(ESTADO == 1){
      
    //Sistema que cuenta cuantos minutos, segundos y horas lleva el modo encendido
   digitalWrite(LUZ, HIGH);
   CONTADOR += 1;
   if(CONTADOR%4 == 0){
    SEGS += 1; //Por cada 4 ciclos (250ms) se sumara 1 al espacio de segundos

    if(SEGS%60 == 0){
      MINS += 1;
      SEGS -= 60; //Por cada 60s se restará 60 a la casilla de segundos y se sumara 1 a minutos

      if(MINS%60 == 0){
        HRS += 1;
        MINS -= 60; //Por cada 60 minutos se restará 60 a la casilla de minutos y se sumará 1 a horas
      }
    }
   }

    //Impresión de los datos calculados arriba en la LCD
    lcd.print("CONS. ELECTRICO (t)");
    lcd.setCursor(0,1);
    lcd.print(" ");
    lcd.print(HRS);
    lcd.print("h - ");
    lcd.print(MINS);
    lcd.print("m - ");
    lcd.print(SEGS);
    lcd.print("s");
    lcd.home(); 
    }
   }
  
  
  
}

//Función que mide la distancia "D" que mida el sensor en cm
int DISTANCIA(){
  digitalWrite(TRIGGER, HIGH);
  delay(10);
  digitalWrite(TRIGGER, LOW);
  int T = pulseIn(ECHO, HIGH);
  int D = T/59;
  return D; //Retorna la cantidad en cm 
}
